/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.prob.core.sablecc.lexer;

import java.io.*;
import java.util.*;
import de.prob.core.sablecc.node.*;
import de.hhu.stups.sablecc.patch.*;


@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.INIT;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;

	private IToken tok;

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return this.token;
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = this.token;
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.INIT; break;
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.EXCEPTION; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.EXCEPTION; break;
                            }
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }
    Token new1(  int line,   int pos) { return new TNo(line, pos); }
    Token new2(  int line,   int pos) { return new TYes(line, pos); }
    Token new3(  int line,   int pos) { return new TException(line, pos); }
    Token new4(  String text,   int line,   int pos) { return new TComma(text, line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TLPar(text, line, pos); }
    Token new6(  String text,   int line,   int pos) { return new TRPar(text, line, pos); }
    Token new7(  String text,   int line,   int pos) { return new TLSq(text, line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TRSq(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TNumber(text, line, pos); }
    Token new10(  String text,   int line,   int pos) { return new TName(text, line, pos); }
    Token new11(  String text,   int line,   int pos) { return new TVariable(text, line, pos); }
    Token new12(  String text,   int line,   int pos) { return new TString(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INIT
            {{10, 10, 1}, {13, 13, 2}, {101, 101, 3}, {110, 110, 4}, {121, 121, 5}, },
            {{10, 13, -2}, },
            {{10, 13, -2}, },
            {{120, 120, 6}, },
            {{111, 111, 7}, },
            {{101, 101, 8}, },
            {{99, 99, 9}, },
            {},
            {{115, 115, 10}, },
            {{101, 101, 11}, },
            {},
            {{112, 112, 12}, },
            {{116, 116, 13}, },
            {{105, 105, 14}, },
            {{111, 111, 15}, },
            {{110, 110, 16}, },
            {},
        }
        { // NORMAL
            {{10, 10, 1}, {13, 13, 2}, {17, 17, 3}, {33, 33, 4}, {35, 35, 5}, {36, 36, 6}, {38, 38, 7}, {39, 39, 8}, {40, 40, 9}, {41, 41, 10}, {42, 42, 11}, {43, 43, 12}, {44, 44, 13}, {45, 45, 14}, {46, 46, 15}, {47, 47, 16}, {48, 57, 17}, {58, 58, 18}, {59, 59, 19}, {60, 60, 20}, {61, 61, 21}, {62, 62, 22}, {63, 63, 23}, {64, 64, 24}, {65, 90, 25}, {91, 91, 26}, {92, 92, 27}, {93, 93, 28}, {94, 94, 29}, {95, 95, 30}, {97, 122, 31}, {123, 123, 32}, {126, 126, 33}, {186, 186, 34}, {192, 214, 25}, {216, 222, 25}, {223, 246, 35}, {248, 255, 36}, },
            {{10, 13, -2}, },
            {{10, 13, -2}, },
            {{17, 17, 37}, {48, 57, 38}, {65, 90, 39}, {95, 95, 40}, {97, 122, 41}, {186, 186, 42}, {192, 214, 39}, {216, 222, 39}, {223, 246, 43}, {248, 255, 44}, },
            {},
            {{35, 38, -2}, {42, 43, -2}, {45, 45, 45}, {46, 47, -2}, {58, 58, 18}, {60, 64, -2}, {92, 92, 27}, {94, 94, 29}, {126, 126, 33}, },
            {{35, 126, -7}, },
            {{35, 126, -7}, },
            {{0, 38, 46}, {39, 39, 47}, {40, 91, 46}, {92, 92, 48}, {93, 65535, 46}, },
            {},
            {},
            {{35, 126, -7}, },
            {{35, 126, -7}, },
            {},
            {{35, 47, -7}, {48, 57, 49}, {58, 126, -7}, },
            {{35, 126, -7}, },
            {{35, 126, -7}, },
            {{48, 57, 17}, },
            {{35, 126, -7}, },
            {},
            {{35, 126, -7}, },
            {{35, 126, -7}, },
            {{35, 126, -7}, },
            {{35, 126, -7}, },
            {{35, 126, -7}, },
            {{17, 17, 50}, {48, 57, 51}, {65, 90, 52}, {95, 95, 53}, {97, 122, 54}, {186, 186, 55}, {192, 214, 52}, {216, 222, 52}, {223, 246, 56}, {248, 255, 57}, },
            {{93, 93, 58}, },
            {{35, 126, -7}, },
            {},
            {{35, 126, -7}, },
            {{17, 17, 59}, {48, 57, 60}, {65, 90, 61}, {95, 95, 62}, {97, 122, 63}, {186, 186, 64}, {192, 214, 61}, {216, 222, 61}, {223, 246, 65}, {248, 255, 66}, },
            {{17, 255, -5}, },
            {{125, 125, 67}, },
            {{35, 126, -7}, },
            {{17, 255, -5}, },
            {{17, 255, -5}, },
            {{17, 255, -5}, },
            {{17, 255, -5}, },
            {{17, 255, -5}, },
            {{17, 255, -5}, },
            {{17, 255, -5}, },
            {{17, 255, -5}, },
            {{17, 255, -5}, },
            {{17, 255, -5}, },
            {{17, 255, -5}, },
            {{35, 126, -7}, },
            {{0, 65535, -10}, },
            {},
            {{0, 38, 46}, {39, 39, 68}, {40, 65535, -10}, },
            {{48, 57, 49}, },
            {{17, 255, -27}, },
            {{17, 255, -27}, },
            {{17, 255, -27}, },
            {{17, 255, -27}, },
            {{17, 255, -27}, },
            {{17, 255, -27}, },
            {{17, 255, -27}, },
            {{17, 255, -27}, },
            {},
            {{17, 255, -32}, },
            {{17, 255, -32}, },
            {{17, 255, -32}, },
            {{17, 255, -32}, },
            {{17, 255, -32}, },
            {{17, 255, -32}, },
            {{17, 255, -32}, },
            {{17, 255, -32}, },
            {},
            {{0, 65535, -10}, },
        }
        { // EXCEPTION
            {{0, 65535, 1}, },
            {{0, 65535, 1}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INIT
        {0, 0, 0, -1, -1, -1, -1, 1, -1, -1, 2, -1, -1, -1, -1, -1, 3, },
        // NORMAL
        {0, 0, 0, 10, 10, 10, 10, 10, -1, 5, 6, 10, 10, 4, 10, 10, 10, 9, 10, 10, 10, 10, 10, 10, 10, 11, 7, 10, 8, 10, 11, 10, -1, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, -1, 10, -1, 9, 11, 11, 11, 11, 11, 11, 11, 11, 10, 11, 11, 11, 11, 11, 11, 11, 11, 10, 10, },
        // EXCEPTION
        {12, 12, },

    };*/

    public static class State
    {
        public final static State INIT = new State(0);
        public final static State NORMAL = new State(1);
        public final static State EXCEPTION = new State(2);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
